package ru.dbotthepony.kommons.test

import org.junit.jupiter.api.DisplayName
import org.junit.jupiter.api.Test
import ru.dbotthepony.kommons.util.XXHash32
import ru.dbotthepony.kommons.util.XXHash64
import ru.dbotthepony.kommons.util.digest2string
import kotlin.test.assertEquals

object HashingTests {
	@Test
	@DisplayName("xxHash64 implementation")
	fun xxHash64() {
		val str = "Nobody inspects the spammish repetition"
		val hasher = XXHash32()
		hasher.update(str.toByteArray())
		assertEquals("e2293b2f", digest2string(hasher.digest()))

		val hasher2 = XXHash64()
		hasher2.update(str.toByteArray())
		assertEquals("fbcea83c8a378bf1", digest2string(hasher2.digest()))
	}
}
